<?php

namespace Drupal\private_dns\Controller;

use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation;
// Set
// http://d9.playground/private_dns/set/10.0.0.44/cubo/d41d8cd98f00b204e9800998ecf8427e

// Get
// http://d9.playground/private_dns/get/0/cubo/00




/**
 * @file
 * Contains \Drupal\private_dns\Controller\PrivateDnsController.
 */


class PrivateDnsController {


  public function set ($ip , $name , $key)  {

    $ip        = $_SERVER['SERVER_NAME']; //\Drupal::request()->getServerIp();
    $args      = private_dns_get_args();
    $name      = private_dns_clean_name($args[2]);
    $key       = $args[3];

    private_dns_validate_key($key, "s");

    $is_valid = private_dns_validate_ip($ip,  "s");

    if ($is_valid == TRUE)   {
      \Drupal::state()->set('private_dns_ip_0'  , $ip);
      \Drupal::state()->set('private_dns_name_0', $name);
      \Drupal::state()->set('private_dns_key_0' , $key);
      echo "IP set as " . \Drupal::state()->get('private_dns_ip_0' ,"");
      //echo "NAME set as " . \Drupal::state()->get('private_dns_name_0' ,"");
      exit;
    }
    echo "nothing new...";
    exit;
  }



  public function get ($ip , $name , $key)  {

    private_dns_validate_key($key, "g");

    $data = [];
    $data['ip']   = \Drupal::state()->get('private_dns_ip_0'  , null);
    $data['name'] = \Drupal::state()->get('private_dns_name_0', null);
    $data['key']  = \Drupal::state()->get('private_dns_key_0' , null);
    // we only need a verfy basic output here...
    echo $data['ip'];
    exit;
  }


  /*
  * This function proposes a script to update local host file
  * we start using approach at https://stackoverflow.com/a/28459928/195812
  */
  public function create_file_hosts_script ($name, $key)  {
    private_dns_validate_key($key, "cfhs");
    $host = \Drupal::request()->getHost();
    $domain_with_schema = \Drupal::request()->getSchemeAndHttpHost();
    $args    = private_dns_get_args();

    if (!isset( $args[2]))  {
      $args[2] = "-";
    }

    $output = '' ;
    $output .= '<h1>' . t('Flow') . '</h1>'  ;
    $output .= '<h2> <b>A.</b> ' . t('Update the Private DNS table from the server behind the dynamic IP. Useful when run via crontab.', [ ] ) . '</h2>';
    $script  = "<br/><br/><code>\r\n";
    $script .= "#! /bin/bash<br/>";

    $script .= "#TIPS:<br/>";
    $script .= "# On Ubuntu you can set hosname.domain with<br/>";
    $script .= "# \"sudo hostnamectl set-hostname MYHOSTNAME.DOMAIN\" <br/>";
    $script .= "# then reboot. <br/>";
    $script .= "<br/>";
    $script .= "<br/>";

    //https://unix.stackexchange.com/a/38237/47662
    $script .= "NAME=`uname -n`.`awk '/^domain/ {print $2}' /etc/resolv.conf` <br/>\r\n";
    $script .= "wget -qO-  ". $domain_with_schema.PRIVATE_DNS_BASE_CALL."/set/\${NAME}/". PRIVATE_DNS_KEY   ."<br/>";



    //$script .= "#IP=$(dig +short myip.opendns.com @resolver1.opendns.com)<br/>";
    //$script .= "HOST=\"".$args[2]."\"<br/>";
    //$script .= "sed -i \"/\$HOST/ s/.*/\$IP\t\$HOST/g\" /etc/hosts  <br/>";
    $script .= "</code><br/><br/><br/><br/>";
    $output .= $script;


    $output .= '<h2> <b>B.</b> ' . t('Update the /etc/hosts file of your client. Run the script below via crontab') . '</h2>';

    $script  = "<br/><br/><code>\r\n";
    $script .= "#! /bin/bash<br/>";
    $script .= "#type below the FQMN you need to access to... <br/>";
    $script .= "NAME_TO_RESOLVE='ServerName.DomainName';<br/>";
    $script .= "IP=\"'wget -qO- ".$domain_with_schema.PRIVATE_DNS_BASE_CALL."/get/\${NAME_TO_RESOLVE}/". PRIVATE_DNS_KEY   ."'\"<br/>";
    $script .= "sed -i \"/\$NAME_TO_RESOLVE/ s/.*/\$IP\t\$NAME_TO_RESOLVE/g\" /etc/hosts  <br/>";
    $script .= "</code><br/><br/><br/><br/>";
    $output .= $script;

    return array(
      '#type' => 'markup',
      '#markup' => $output,
    );
  }


  function getClientIP ()  {
    return   \Drupal::request()->getClientIp();
  }

}
